Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class PrintStream

    java.lang.Object
      |
      +--java.io.OutputStream
            |
            +--java.io.FilterOutputStream
                  |
                  +--java.io.PrintStream

Direct Known Subclasses:
  LogStream

public class PrintStream
extends FilterOutputStream

A `PrintStream` adds functionality to another output stream, namely the ability to print representations of various data values conveniently. Two other features are provided as well. Unlike other output streams, a `PrintStream` never throws an `IOException`; instead, exceptional situations merely set an internal flag that can be tested via the `checkError` method. Optionally, a `PrintStream` can be created so as to flush automatically; this means that the `flush` method is automatically invoked after a byte array is written, one of the `println` methods is invoked, or a newline character or byte (`'\n'`) is written.

All characters printed by a `PrintStream` are converted into bytes using the platform's default character encoding. The ``PrintWriter`` class should be used in situations that require writing characters rather than bytes.

Since:
  JDK1.0

Field Summary

Fields inherited from class java.io.FilterOutputStream
`out`

Constructor Summary
`PrintStream(OutputStream out)` Create a new print stream.
`PrintStream(OutputStream out, boolean autoFlush)` Create a new print stream.
`PrintStream(OutputStream out, boolean autoFlush, String encoding)` Create a new print stream.

Method Summary
`boolean` | `checkError()` Flush the stream and check its error state.
`void` | `close()` Close the stream.
`void` | `flush()` Flush the stream.
`void` | `print(boolean b)` Print a boolean value.
`void` | `print(char c)` Print a character.
`void` | `print(char[] s)` Print an array of characters.
`void` | `print(double d)` Print a double-precision floating-point number.
`void` | `print(float f)` Print a floating-point number.
`void` | `print(int i)` Print an integer.
`void` | `print(long l)` Print a long integer.
`void` | `print(Object obj)` Print an object.
`void` | `print(String s)` Print a string.
`void` | `println()` Terminate the current line by writing the line separator string.
`void` | `println(boolean x)` Print a boolean and then terminate the line.
`void` | `println(char x)` Print a character and then terminate the line.
`void` | `println(char[] x)` Print an array of characters and then terminate the line.
`void` | `println(double x)` Print a double and then terminate the line.
`void` | `println(float x)` Print a float and then terminate the line.
`void` | `println(int x)` Print an integer and then terminate the line.
`void` | `println(long x)` Print a long and then terminate the line.
`void` | `println(Object x)` Print an Object and then terminate the line.
`void` | `println(String x)` Print a String and then terminate the line.
`protected void` | `setError()` Set the error state of the stream to `true`.
`void` | `write(byte[] buf, int off, int len)` Write `len` bytes from the specified byte array starting at offset `off` to this stream.
`void` | `write(int b)` Write the specified byte to this stream.

Methods inherited from class java.io.FilterOutputStream
`write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PrintStream

    public PrintStream(OutputStream out)

  Create a new print stream. This stream will not flush automatically.

Parameters:
  `out` - The output stream to which values and objects will be printed
See Also:
  `PrintWriter.PrintWriter(java.io.OutputStream)`

### PrintStream

    public PrintStream(OutputStream out,
                       boolean autoFlush)

  Create a new print stream.

Parameters:
  `out` - The output stream to which values and objects will be printed
  `autoFlush` - A boolean; if true, the output buffer will be flushed whenever a byte array is written, one of the `println` methods is invoked, or a newline character or byte (`'\n'`) is written
See Also:
  `PrintWriter.PrintWriter(java.io.OutputStream, boolean)`

### PrintStream

    public PrintStream(OutputStream out,
                       boolean autoFlush,
                       String encoding)
                throws UnsupportedEncodingException

  Create a new print stream.

Parameters:
  `out` - The output stream to which values and objects will be printed
  `autoFlush` - A boolean; if true, the output buffer will be flushed whenever a byte array is written, one of the `println` methods is invoked, or a newline character or byte (`'\n'`) is written
  `encoding` - The name of a supported character encoding
Throws:
  `UnsupportedEncodingException` - If the named encoding is not supported

Method Detail

### flush

    public void flush()

  Flush the stream. This is done by writing any buffered output bytes to the underlying output stream and then flushing that stream.

  Overrides:
    `flush` in class `FilterOutputStream`
  See Also:
    `OutputStream.flush()`

### close

    public void close()

  Close the stream. This is done by flushing the stream and then closing the underlying output stream.

  Overrides:
    `close` in class `FilterOutputStream`
  See Also:
    `OutputStream.close()`

### checkError

    public boolean checkError()

  Flush the stream and check its error state. The internal error state is set to `true` when the underlying output stream throws an `IOException` other than `InterruptedIOException`, and when the `setError` method is invoked. If an operation on the underlying output stream throws an `InterruptedIOException`, then the `PrintStream` converts the exception back into an interrupt by doing:

           Thread.currentThread().interrupt();

  or the equivalent.

  Returns:
    True if and only if this stream has encountered an `IOException` other than `InterruptedIOException`, or the `setError` method has been invoked

### setError

    protected void setError()

  Set the error state of the stream to `true`.

  Since:
    JDK1.1

### write

    public void write(int b)

  Write the specified byte to this stream. If the byte is a newline and automatic flushing is enabled then the `flush` method will be invoked.

  Note that the byte is written as given; to write a character that will be translated according to the platform's default character encoding, use the `print(char)` or `println(char)` methods.

  Overrides:
    `write` in class `FilterOutputStream`
  Parameters:
    `b` - The byte to be written
  See Also:
    `print(char)`, `println(char)`

### write

    public void write(byte[] buf,
                      int off,
                      int len)

  Write `len` bytes from the specified byte array starting at offset `off` to this stream. If automatic flushing is enabled then the `flush` method will be invoked.

  Note that the bytes will be written as given; to write characters that will be translated according to the platform's default character encoding, use the `print(char)` or `println(char)` methods.

  Overrides:
    `write` in class `FilterOutputStream`
  Parameters:
    `buf` - A byte array
    `off` - Offset from which to start taking bytes
    `len` - Number of bytes to write
  See Also:
    `FilterOutputStream.write(int)`

### print

    public void print(boolean b)

  Print a boolean value. The string produced by ``String.valueOf(boolean)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `b` - The `boolean` to be printed

### print

    public void print(char c)

  Print a character. The character is translated into one or more bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `c` - The `char` to be printed

### print

    public void print(int i)

  Print an integer. The string produced by ``String.valueOf(int)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `i` - The `int` to be printed
  See Also:
    `Integer.toString(int)`

### print

    public void print(long l)

  Print a long integer. The string produced by ``String.valueOf(long)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `l` - The `long` to be printed
  See Also:
    `Long.toString(long)`

### print

    public void print(float f)

  Print a floating-point number. The string produced by ``String.valueOf(float)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `f` - The `float` to be printed
  See Also:
    `Float.toString(float)`

### print

    public void print(double d)

  Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `d` - The `double` to be printed
  See Also:
    `Double.toString(double)`

### print

    public void print(char[] s)

  Print an array of characters. The characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `s` - The array of chars to be printed
  Throws:
    `NullPointerException` - If `s` is `null`

### print

    public void print(String s)

  Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `s` - The `String` to be printed

### print

    public void print(Object obj)

  Print an object. The string produced by the ``String.valueOf(Object)`` method is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `obj` - The `Object` to be printed
  See Also:
    `Object.toString()`

### println

    public void println()

  Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`).

### println

    public void println(boolean x)

  Print a boolean and then terminate the line. This method behaves as though it invokes ``print(boolean)`` and then ``println()``.

  Parameters:
    `x` - The `boolean` to be printed

### println

    public void println(char x)

  Print a character and then terminate the line. This method behaves as though it invokes ``print(char)`` and then ``println()``.

  Parameters:
    `x` - The `char` to be printed.

### println

    public void println(int x)

  Print an integer and then terminate the line. This method behaves as though it invokes ``print(int)`` and then ``println()``.

  Parameters:
    `x` - The `int` to be printed.

### println

    public void println(long x)

  Print a long and then terminate the line. This method behaves as though it invokes ``print(long)`` and then ``println()``.

  Parameters:
    `x` - a The `long` to be printed.

### println

    public void println(float x)

  Print a float and then terminate the line. This method behaves as though it invokes ``print(float)`` and then ``println()``.

  Parameters:
    `x` - The `float` to be printed.

### println

    public void println(double x)

  Print a double and then terminate the line. This method behaves as though it invokes ``print(double)`` and then ``println()``.

  Parameters:
    `x` - The `double` to be printed.

### println

    public void println(char[] x)

  Print an array of characters and then terminate the line. This method behaves as though it invokes ``print(char[])`` and then ``println()``.

  Parameters:
    `x` - an array of chars to print.

### println

    public void println(String x)

  Print a String and then terminate the line. This method behaves as though it invokes ``print(String)`` and then ``println()``.

  Parameters:
    `x` - The `String` to be printed.

### println

    public void println(Object x)

  Print an Object and then terminate the line. This method behaves as though it invokes ``print(Object)`` and then ``println()``.

  Parameters:
    `x` - The `Object` to be printed.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.